#include <curses.h>
#include "para.h"

//int xscale[] = {0, 10, 40, 200, 255, 255};
int xscale[] = {0, 1, 2, 3, 5, 7, 10, 14, 20, 28, 40, 54, 74, 101, 137, 187, 255};

#define NUM_BANDS sizeof(xscale) / sizeof(int)
int bar_heights[NUM_BANDS];
int scale;
char data[2048];
WINDOW *bars[NUM_BANDS];

#define SCALE COLS / 7
static void draw_func(void)
{
	char buf[1000];
        int i;
        for (i = 0; i < NUM_BANDS; i++) {
		memset (buf, 'x', bar_heights[i]);
//	fprintf(stderr, "height[%d] = %d\n", i, bar_heights[i]);
//		wclear(bars[i]);
		memset(bar_heights[i] + buf, ' ', COLS - bar_heights[i]);
		buf[COLS] = '\0';
		wmove(bars[i], 0, 0);
		waddstr(bars[i], buf);
		wrefresh(bars[i]);
	}
}
static void init_wins(void)
{
        int i;
        for (i = 0; i < NUM_BANDS; i++) {
		bars[i] = newwin(1, COLS, i , 0);
	}
}

static void render(void)
{
        int i, c;
	int y;

        for (i = 0; i < NUM_BANDS - 1; i++) {
                for (c = xscale[i], y = 0; c < xscale[i + 1]; c++)
                        if (data[4 * c + 1] > y)
                                y = data[4 * c + 1];
//                y >>= 7;
                if (y) {
                        y = (int)(log(y) * SCALE);
                        if (y > COLS - 1)
                                y = COLS - 1;
                }
                if (y > bar_heights[i])
                        bar_heights[i] = y;
                else if (bar_heights[i] > 4)
                      bar_heights[i] -= 4;
                else
                       bar_heights[i] = 0;
//	fprintf(stderr, "afdraw\n");
        }
        draw_func();
        return;
}

static void init_curses(void)
{
	initscr();
	curs_set(0); /* make cursor invisible, ignore errors */
//	if (noraw() == ERR);
//		msg_n_exit(EXIT_FAILURE, "can not place terminal out of "
//			"raw mode\n");
	nonl(); /* tell curses not to do NL->CR/NL on output */
	noecho(); /* don't echo input */
	cbreak(); /* take input chars one at a time, no wait for \n */
	//reset_prog_mode();
	clear();
	noecho(); /* don't echo input */
	init_wins();
}

int main(int argc, char **argv)
{
	FILE *f = popen("./para_audioc grab mp3 2 s", "r");
	int fd;

	if (!f)
		return -1;
	fd = fileno(f);
	init_curses();
	draw_func();
	while (read(fd, data, sizeof(data)) > 0) {
		render();
		sleep(1);
	}
	endwin();
	return 1;
}
